/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.xslt.sdk;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

/**
 * 
 * @author ofabre
 *
 */
public class XsltImpl implements Xslt {

    public XsltImpl() {
        super();
    }

    public Source transform(Source xml, String xslPath)
        throws TransformerException {

        Source source = new StreamSource(xslPath);
        TransformerFactory transformerFactory = TransformerFactory
            .newInstance();
        Transformer transformer = transformerFactory.newTemplates(source)
            .newTransformer();

        ByteArrayOutputStream outputStream = transformSource(xml, transformer);

        return createSourceFromStreamResult(outputStream);
    }

    private StreamSource createSourceFromStreamResult(
        ByteArrayOutputStream outputStream) {
        StreamSource sourceResult = new StreamSource();
        ByteArrayInputStream result = new ByteArrayInputStream(outputStream
            .toByteArray());
        sourceResult.setInputStream(result);
        return sourceResult;
    }

    private ByteArrayOutputStream transformSource(Source xml,
        Transformer transformer) throws TransformerException {
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        Result streamResult = new StreamResult(outputStream);
        transformer.transform(xml, streamResult);
        return outputStream;
    }

}
